Package org.eclipse.cdt.core.settings.model

# Interface ICSettingEntry

All Known Subinterfaces:
  `ICExclusionPatternPathEntry`, `ICIncludeFileEntry`, `ICIncludePathEntry`, `ICLanguageSettingEntry`, `ICLanguageSettingPathEntry`, `ICLibraryFileEntry`, `ICLibraryPathEntry`, `ICMacroEntry`, `ICMacroFileEntry`, `ICOutputEntry`, `ICPathEntry`, `ICSourceEntry`

All Known Implementing Classes:
  `ACExclusionFilterEntry`, `ACPathEntry`, `ACSettingEntry`, `CIncludeFileEntry`, `CIncludePathEntry`, `CLibraryFileEntry`, `CLibraryPathEntry`, `CMacroEntry`, `CMacroFileEntry`, `COutputEntry`, `CSourceEntry`

public interface ICSettingEntry
An interface representing setting entries.

Restriction:
  This interface is not intended to be implemented by clients. Any class implementing this interface should be immutable so the setting entries could be safely pooled by `CDataUtil.getPooledEntry(ICSettingEntry)`.
Restriction:
  This interface is not intended to be extended by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ALL`
`static final int`
`BUILTIN`
Flag `BUILTIN` indicates settings built in a tool (compiler) itself.
`static final int`
`EXPORTED`
Flag `UNDEFINED` indicates that the entry is "Exported" to referencing projects.
`static final int`
`FRAMEWORKS_MAC`
Flag `FRAMEWORKS_MAC` applies for path entries.
`static final int`
`INCLUDE_FILE`
`static final int`
`INCLUDE_PATH`
`static final int`
`LIBRARY_FILE`
`static final int`
`LIBRARY_PATH`
`static final int`
`LOCAL`
Flag `LOCAL` is used during creation of `IIncludeEntry` to indicate that an include path is not a system path.
`static final int`
`MACRO`
`static final int`
`MACRO_FILE`
`static final int`
`NONE`
A constant known to be zero (0), used to indicate that no flags are set.
`static final int`
`OUTPUT_PATH`
`static final int`
`READONLY`
Flag `READONLY` means that the entry is not intended to be overwritten by user.
`static final int`
`RESOLVED`
Flag `RESOLVED` means that any build or other variables (for example ${ProjDirPath}) have been expanded to their values.
`static final int`
`SOURCE_PATH`
`static final int`
`UNDEFINED`
Flag `UNDEFINED` indicates that the entry should not be defined.
`static final int`
`VALUE_WORKSPACE_PATH`
Flag `VALUE_WORKSPACE_PATH` is used to indicate that the entry is a resource managed by eclipse in the workspace.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equalsByContents(ICSettingEntry entry)`
`boolean`
`equalsByName(ICSettingEntry entry)`
`int`
`getFlags()`
`int`
`getKind()`
`String`
`getName()`
`String`
`getValue()`
`boolean`
`isBuiltIn()`
`boolean`
`isReadOnly()`
`boolean`
`isResolved()`

## Field Details

### NONE

static final int NONE
A constant known to be zero (0), used to indicate that no flags are set.

Since:
  5.6
See Also:
  - Constant Field Values

### BUILTIN

static final int BUILTIN
Flag `BUILTIN` indicates settings built in a tool (compiler) itself. That kind of settings are not passed as options to a compiler but indexer or other clients might need them.

See Also:
  - Constant Field Values

### READONLY

static final int READONLY
Flag `READONLY` means that the entry is not intended to be overwritten by user.

See Also:
  - Constant Field Values

### LOCAL

static final int LOCAL
Flag `LOCAL` is used during creation of `IIncludeEntry` to indicate that an include path is not a system path. "System" path is denoted by angle brackets as in #include <x.h> "Local" path is denoted by quotes as in #include "x.h"

See Also:
  - Constant Field Values

### VALUE_WORKSPACE_PATH

static final int VALUE_WORKSPACE_PATH
Flag `VALUE_WORKSPACE_PATH` is used to indicate that the entry is a resource managed by eclipse in the workspace. It does not always mean that the path is rooted in the workspace root. In some cases it may be a project path.

See Also:
  - Constant Field Values

### RESOLVED

static final int RESOLVED
Flag `RESOLVED` means that any build or other variables (for example ${ProjDirPath}) have been expanded to their values.

See Also:
  - Constant Field Values

### UNDEFINED

static final int UNDEFINED
Flag `UNDEFINED` indicates that the entry should not be defined. It's main purpose to provide the means to negate entries defined elsewhere.

Since:
  5.4
See Also:
  - Constant Field Values

### FRAMEWORKS_MAC

static final int FRAMEWORKS_MAC
Flag `FRAMEWORKS_MAC` applies for path entries. Such a path entry will be treated in a special way to imitate resolving paths by Apple's version of gcc, see bug 69529.

Since:
  5.4
See Also:
  - Constant Field Values

### EXPORTED

static final int EXPORTED
Flag `UNDEFINED` indicates that the entry is "Exported" to referencing projects. It will be passed to the projects configurations referencing the configuration the entry belongs to.

Since:
  5.6
See Also:
  - Constant Field Values

### INCLUDE_PATH

static final int INCLUDE_PATH

See Also:
  - Constant Field Values

### INCLUDE_FILE

static final int INCLUDE_FILE

See Also:
  - Constant Field Values

### MACRO

static final int MACRO

See Also:
  - Constant Field Values

### MACRO_FILE

static final int MACRO_FILE

See Also:
  - Constant Field Values

### LIBRARY_PATH

static final int LIBRARY_PATH

See Also:
  - Constant Field Values

### LIBRARY_FILE

static final int LIBRARY_FILE

See Also:
  - Constant Field Values

### OUTPUT_PATH

static final int OUTPUT_PATH

See Also:
  - Constant Field Values

### SOURCE_PATH

static final int SOURCE_PATH

See Also:
  - Constant Field Values

### ALL

static final int ALL

See Also:
  - Constant Field Values

## Method Details

### isReadOnly

boolean isReadOnly()

### getKind

int getKind()

### getName

String getName()

### getValue

String getValue()

### isBuiltIn

boolean isBuiltIn()

### isResolved

boolean isResolved()

### equalsByName

boolean equalsByName(ICSettingEntry entry)

### equalsByContents

boolean equalsByContents(ICSettingEntry entry)

### getFlags

int getFlags()